;
; N A M E : x s e e k . a s m
;
; D E S C : sys__llseek() stub function for GCC
;
; A U T H : Wataru Nishida, M.D., Ph.D.
;           wnishida@skyfree.org
;           http://www.skyfree.org
;
; M A K E : nasm -f elf xseek.asm
;
; V E R S : 1.0
;
; D A T E : Dec. 2nd, 2000
;

bits	32
section	.text
global	xseek

;
;   x s e e k
;
;   --- Linux specific eXtended lSEEK function, which enable 64bit
;	length addressing on non 64bit architecture.
;
;   +++ GLIBC already supported llseek(), but it returns loff_t
;	and the result is omitted. So I created new function and
;	named it as 'xseek'.
;
;	int xseek (unsigned int fd, loff_t* offset, loff_t* new_pos,
;		   unsigned int whence )
;
;						Dec. 2, 2000

xseek:
	push	ebp			; Remember EBP.
	mov	ebp, esp		; Prepare stack frame.

	push	edi			; Save general registers.
	push	esi
	push	ebx

	mov	esi, [ ebp + 12 ]	; Get address of 'offset'.
	mov	edx, [ esi ]		; Set lower offset address.
	mov	ecx, [ esi + 4 ]	; Set higher offset address.

	mov	edi, [ ebp + 20 ]	; Set 'whence'.
	mov	esi, [ ebp + 16 ]	; Set 'new_pos'.
	mov	ebx, [ ebp +  8 ]	; Set 'fd'.

	mov	eax, 140		; Call sys__llseek().
	int	0x80			; Syscall nums in <asm/unistd.h>.

	pop	ebx			; Recover registers.
	pop	esi
	pop	edi

	leave				; Perform ESP=EBP and EBP=pop().
	ret
